/*
	Emailscanner - The program filters email addresses from a file.
	Copyright 2020 Marek Küthe
	
	This program is free software. It comes without any warranty, to
	the extent permitted by applicable law. You can redistribute it
	and/or modify it under the terms of the Do What The Fuck You Want
	To Public License, Version 2, as published by Sam Hocevar. See
	http://www.wtfpl.net/ for more details.
*/

package emailscanner;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.GridBagLayout;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import javax.swing.SwingConstants;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.awt.Font;
import java.awt.Insets;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.awt.event.ActionEvent;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;

public class MainWindow {
	
	protected JFrame frmEmailscanner;
	protected ImageIcon checkmark;
	protected ImageIcon notcompletely;
	
	{
		checkmark = new ImageIcon(MainWindow.class.getResource("/images/checkmark.png"));
		notcompletely = new ImageIcon(MainWindow.class.getResource("/images/notcompletely.png"));
	}
	
	
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					MainWindow window = new MainWindow();
					window.frmEmailscanner.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	
	public MainWindow() {
		initialize();
	}

	private void initialize() {
		/* Most of the GUI source code was generated with Eclipse's WindowBuilder. */
		
		frmEmailscanner = new JFrame();
		frmEmailscanner.setTitle("Emailscanner");
		frmEmailscanner.setBounds(100, 100, 450, 475);
		frmEmailscanner.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{450, 0};
		gridBagLayout.rowHeights = new int[]{15, 0, 0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{1.0, Double.MIN_VALUE};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 0.0, 0.0, 1.0, Double.MIN_VALUE};
		frmEmailscanner.getContentPane().setLayout(gridBagLayout);
		
		JLabel TitleLabel = new JLabel("Emailscanner");
		TitleLabel.setFont(new Font("DejaVu Serif", Font.BOLD, 21));
		TitleLabel.setVerticalAlignment(SwingConstants.TOP);
		TitleLabel.setHorizontalAlignment(SwingConstants.CENTER);
		GridBagConstraints gbc_TitleLabel = new GridBagConstraints();
		gbc_TitleLabel.insets = new Insets(0, 0, 5, 0);
		gbc_TitleLabel.anchor = GridBagConstraints.NORTH;
		gbc_TitleLabel.fill = GridBagConstraints.HORIZONTAL;
		gbc_TitleLabel.gridx = 0;
		gbc_TitleLabel.gridy = 0;
		frmEmailscanner.getContentPane().add(TitleLabel, gbc_TitleLabel);
		
		JLabel descLabel = new JLabel("This program filters out email addresses from a file.");
		descLabel.setHorizontalAlignment(SwingConstants.LEFT);
		GridBagConstraints gbc_descLabel = new GridBagConstraints();
		gbc_descLabel.insets = new Insets(0, 0, 5, 0);
		gbc_descLabel.gridx = 0;
		gbc_descLabel.gridy = 1;
		frmEmailscanner.getContentPane().add(descLabel, gbc_descLabel);
		
		JLabel descAcceptFilesLabel = new JLabel("It accepts txt, html and odt files.");
		descAcceptFilesLabel.setHorizontalAlignment(SwingConstants.LEFT);
		GridBagConstraints gbc_descAcceptFilesLabel = new GridBagConstraints();
		gbc_descAcceptFilesLabel.insets = new Insets(0, 0, 5, 0);
		gbc_descAcceptFilesLabel.gridx = 0;
		gbc_descAcceptFilesLabel.gridy = 2;
		frmEmailscanner.getContentPane().add(descAcceptFilesLabel, gbc_descAcceptFilesLabel);
		
		JPanel panel = new JPanel();
		GridBagConstraints gbc_panel = new GridBagConstraints();
		gbc_panel.fill = GridBagConstraints.BOTH;
		gbc_panel.gridx = 0;
		gbc_panel.gridy = 4;
		frmEmailscanner.getContentPane().add(panel, gbc_panel);
		GridBagLayout gbl_panel = new GridBagLayout();
		gbl_panel.columnWidths = new int[]{0, 0, 0};
		gbl_panel.rowHeights = new int[]{0, 0, 0, 0, 0};
		gbl_panel.columnWeights = new double[]{1.0, 0.0, Double.MIN_VALUE};
		gbl_panel.rowWeights = new double[]{0.0, 0.0, 0.0, 1.0, Double.MIN_VALUE};
		panel.setLayout(gbl_panel);
		
		JLabel SelectAFileLabel = new JLabel("Select a file");
		SelectAFileLabel.setIcon(this.notcompletely);
		GridBagConstraints gbc_SelectAFileLabel = new GridBagConstraints();
		gbc_SelectAFileLabel.anchor = GridBagConstraints.WEST;
		gbc_SelectAFileLabel.insets = new Insets(0, 0, 5, 5);
		gbc_SelectAFileLabel.gridx = 0;
		gbc_SelectAFileLabel.gridy = 0;
		panel.add(SelectAFileLabel, gbc_SelectAFileLabel);
		
		JButton SelectFileButton = new JButton("Select file");
		GridBagConstraints gbc_SelectFileButton = new GridBagConstraints();
		gbc_SelectFileButton.anchor = GridBagConstraints.EAST;
		gbc_SelectFileButton.insets = new Insets(0, 0, 5, 0);
		gbc_SelectFileButton.gridx = 1;
		gbc_SelectFileButton.gridy = 0;
		panel.add(SelectFileButton, gbc_SelectFileButton);
		
		JLabel ExtractLabel = new JLabel("Extract the contents of the file");
		ExtractLabel.setIcon(notcompletely);
		GridBagConstraints gbc_ExtractLabel = new GridBagConstraints();
		gbc_ExtractLabel.anchor = GridBagConstraints.WEST;
		gbc_ExtractLabel.insets = new Insets(0, 0, 5, 5);
		gbc_ExtractLabel.gridx = 0;
		gbc_ExtractLabel.gridy = 1;
		panel.add(ExtractLabel, gbc_ExtractLabel);
		
		JButton ExtractButton = new JButton("Extract");
		ExtractButton.setEnabled(false);
		GridBagConstraints gbc_ExtractButton = new GridBagConstraints();
		gbc_ExtractButton.anchor = GridBagConstraints.EAST;
		gbc_ExtractButton.insets = new Insets(0, 0, 5, 0);
		gbc_ExtractButton.gridx = 1;
		gbc_ExtractButton.gridy = 1;
		panel.add(ExtractButton, gbc_ExtractButton);
		
		JLabel FindLabel = new JLabel("Find email addresses");
		FindLabel.setIcon(notcompletely);
		GridBagConstraints gbc_FindLabel = new GridBagConstraints();
		gbc_FindLabel.anchor = GridBagConstraints.WEST;
		gbc_FindLabel.insets = new Insets(0, 0, 5, 5);
		gbc_FindLabel.gridx = 0;
		gbc_FindLabel.gridy = 2;
		panel.add(FindLabel, gbc_FindLabel);
		
		JButton FindButton = new JButton("Find");
		FindButton.setEnabled(false);
		GridBagConstraints gbc_FindButton = new GridBagConstraints();
		gbc_FindButton.insets = new Insets(0, 0, 5, 0);
		gbc_FindButton.anchor = GridBagConstraints.EAST;
		gbc_FindButton.gridx = 1;
		gbc_FindButton.gridy = 2;
		panel.add(FindButton, gbc_FindButton);
		
		JScrollPane scrollPane = new JScrollPane();
		GridBagConstraints gbc_scrollPane = new GridBagConstraints();
		gbc_scrollPane.gridwidth = 2;
		gbc_scrollPane.insets = new Insets(0, 0, 0, 5);
		gbc_scrollPane.fill = GridBagConstraints.BOTH;
		gbc_scrollPane.gridx = 0;
		gbc_scrollPane.gridy = 3;
		panel.add(scrollPane, gbc_scrollPane);
		
		JTextArea EmailsTextArea = new JTextArea();
		EmailsTextArea.setFont(new Font("Monospaced", Font.PLAIN, 14));
		EmailsTextArea.setEditable(false);
		scrollPane.setViewportView(EmailsTextArea);
		

		ExtractButton.addActionListener(new ActionListener() {
			/**
			 * Extracts the contents of the file
			 */
			public void actionPerformed(ActionEvent arg0) {
				try {
					Extractor.EXT_TYPE type = null;

					if(Store.selectedFile.getName().endsWith(".html"))
						type = Extractor.EXT_TYPE.HTML;
					else if(Store.selectedFile.getName().endsWith(".txt"))
						type = Extractor.EXT_TYPE.TXT;
					else if(Store.selectedFile.getName().endsWith(".odt"))
						type = Extractor.EXT_TYPE.ODT;
					else
						throw new RuntimeException("The file extension could not be used to determine which file type it is.");
					
					Store.extractor.extract(type);
					
					ExtractLabel.setIcon(checkmark);
					ExtractButton.setEnabled(false);
					FindButton.setEnabled(true);
				} catch (Exception e) {
					Misc.ExceptionHandler(e, frmEmailscanner);
				}
			}
		});

		SelectFileButton.addActionListener(new ActionListener() {
			/**
			 * Selects a file and initializes an extractor to read the file.
			 */
			public void actionPerformed(ActionEvent arg0) {
				try {
					JFileChooser chooser = new JFileChooser();
					chooser.setAcceptAllFileFilterUsed(false);
		            FileNameExtensionFilter filter = new FileNameExtensionFilter("Only .html, .txt and .odt files", "html", "txt", "odt"); 
		            chooser.addChoosableFileFilter(filter); 
					int res = chooser.showOpenDialog(frmEmailscanner);
					
					if(res == JFileChooser.APPROVE_OPTION) {
						
					} else {
						throw new RuntimeException("No file was selected. Please try again.");
					}
					
					Store.selectedFile = chooser.getSelectedFile().getAbsoluteFile();
					Store.extractor = new Extractor(Store.selectedFile);
					
					SelectAFileLabel.setIcon(checkmark);
					SelectFileButton.setEnabled(false);
					ExtractButton.setEnabled(true);
				} catch (Exception e) {
					Misc.ExceptionHandler(e, frmEmailscanner);
				}
			}
		});
		
		FindButton.addActionListener(new ActionListener() {
			/**
			 * Finds the email addresses and outputs them in the text area.
			 */
			public void actionPerformed(ActionEvent arg0) {
				try {
					Store.finder = new Finder(Store.extractor);
					Store.finder.find();
					Iterator<String> iter = Store.finder.getEmailInterator();
					
					while(iter.hasNext()) {
						EmailsTextArea.append(iter.next() + "\n");
					}
					
					FindLabel.setIcon(checkmark);
					FindButton.setEnabled(false);
				} catch (Exception e) {
					Misc.ExceptionHandler(e, frmEmailscanner);
				}
			}
		});
	}

}
