/*
	Emailscanner - The program filters email addresses from a file.
	Copyright 2020 Marek Küthe
	
	This program is free software. It comes without any warranty, to
	the extent permitted by applicable law. You can redistribute it
	and/or modify it under the terms of the Do What The Fuck You Want
	To Public License, Version 2, as published by Sam Hocevar. See
	http://www.wtfpl.net/ for more details.
*/

package emailscanner;

import java.awt.Component;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

import javax.swing.JOptionPane;

public class Misc {
	
	/**
	 * Function that handles errors. In this case this means that the function outputs a message. If this is not possible, another attempt is made to output a message, which, however, cannot be traced back to any parent component and the actual error and the error that occurred when attempting the task are output in the standard error output channel, i.e. the console.
	 * @param exc The error to be reported.
	 * @param parent The parent component to which the error dialog leads back. If the parent component does not exist, zero can be specified.
	 */
	public static void ExceptionHandler(Exception exc, Component parent) {
		StringWriter message = new StringWriter();
		PrintWriter trace = new PrintWriter(message);
		exc.printStackTrace(trace);
		trace.close();
		
		try {
			message.close();
		} catch (IOException e) {
			String strangeMsg = "A strange program error has occurred. See the console for more information.";
			JOptionPane.showMessageDialog(null, strangeMsg + "\n\n" + exc.getMessage(), strangeMsg, JOptionPane.ERROR_MESSAGE);
			
			System.err.println("Strange error:");
			System.err.println(e.getMessage());
			e.printStackTrace(System.err);
			
			System.err.println("Actual error:");
			System.err.println(exc.getMessage());
			exc.printStackTrace(System.err);
		}
		
		JOptionPane.showMessageDialog(parent, exc.getMessage() + "\n\n" + message, exc.getMessage(), JOptionPane.ERROR_MESSAGE);
	}
	
}
